<?php
namespace PME\Controllers\Servico;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ClientesPorServicoController {
	protected $connection;

  public function __construct($connection) {
    $this->connection = $connection;
  }
  
  public function acaoCadastroAutomaticoCliente(DTO\Request $request, DTO\Response $response) {
    try {
        $parameters = $request->getParameters();
        $unidade = $parameters['unidade'];
        $cliente = $parameters['cliente'];
        $cardsPorServs = $parameters['linhasCardPorServ'];
        
        $this->connection->beginTransaction();
        
        $querySelect = "SELECT
                            CDFILCENTPME, CDTIPOCARD, CDCLIENTE,
                            CDSERVFILI, CDFILIAL
                          FROM
                            SERVCLIEPME
                          WHERE
                           (CDFILCENTPME = :P_CDFILCENTPME) AND
                           (CDFILIAL     = :P_CDFILIAL    ) AND
                           (CDTIPOCARD   = :P_CDTIPOCARD  ) AND
                           (CDSERVFILI   = :P_CDSERVFILI  ) AND
                           (CDCLIENTE    = :P_CDCLIENTE   )";
                               
        $queryInsert = "INSERT INTO SERVCLIEPME
                          (CDFILCENTPME, CDTIPOCARD, CDCLIENTE, CDFILIAL, CDSERVFILI)
                        VALUES
                          (:CDFILCENTPME, :CDTIPOCARD, :CDCLIENTE, :CDFILIAL, :CDSERVFILI)
                        ";


        foreach($cardsPorServs as $cardPorServ){
          $paramSelect = array(
            'P_CDFILCENTPME'  => $unidade['CDFILCENTPME'],
            'P_CDFILIAL'      => $unidade['CDFILIAL'],
            'P_CDTIPOCARD'    => $cardPorServ['CDTIPOCARD'],
            'P_CDSERVFILI'    => $cardPorServ['CDSERVFILI'],
            'P_CDCLIENTE'     => $cliente['CDCLIENTE'],
          );
          $verificaClienteUnidade = $this->connection->fetchAll($querySelect, $paramSelect);
          if (sizeof($verificaClienteUnidade) == 0){
            $paramInsert = array(
              'CDFILCENTPME'  => $unidade['CDFILCENTPME'],
              'CDTIPOCARD'    => $cardPorServ['CDTIPOCARD'],
              'CDCLIENTE'     => $cliente['CDCLIENTE'],
              'CDFILIAL'      => $unidade['CDFILIAL'],
              'CDSERVFILI'    => $cardPorServ['CDSERVFILI'],
            );
            $stmt = $this->connection->prepare($queryInsert);
            $stmt->execute($paramInsert);
          }
        }
        $this->connection->commit();
        $response->addDataSet(new DataSet("success", array(true)));
    } catch (\Exception $e) {
    	$this->connection->rollback();
		  $response->setError(new Error($e->getMessage(), 500));
	  }
  }

}


