/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMPRECO                                                */
/* Tabela : ITEMPRECO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Luciana corra                                                */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITEMPRECO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITEMPRECO
GO

CREATE TRIGGER DTULTATU_ITEMPRECO
ON ITEMPRECO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ITEMPRECO', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDTABEPREC='+CDTABEPREC+';'+
                'DTINIVGPREC='+CONVERT(VARCHAR,DTINIVGPREC,103)+';'+'CDPRODUTO='+CDPRODUTO+';'+'CDPRPAITABPR='+CDPRPAITABPR+';',
                GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ITEMPRECO
      SET DTULTATUITPR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ITEMPRECO.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(ITEMPRECO.CDTABEPREC,0)   = ISNULL(INSERTED.CDTABEPREC,0))   AND
            (ISNULL(ITEMPRECO.DTINIVGPREC,CONVERT(DATETIME,'31/12/1899')) =
               ISNULL(INSERTED.DTINIVGPREC,CONVERT(DATETIME,'31/12/1899')))      AND
            (ISNULL(ITEMPRECO.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(ITEMPRECO.CDPRPAITABPR,0) = ISNULL(INSERTED.CDPRPAITABPR,0));

            UPDATE PRODUTO
            SET DTULTATUPROD = GETDATE()
            FROM INSERTED
            WHERE PRODUTO.CDPRODUTO  = INSERTED.CDPRODUTO;

            UPDATE ITMENUCONFTE
            SET DTULTATUITCT = GETDATE()
            FROM INSERTED
            WHERE ITMENUCONFTE.CDIDENTBUTON  = INSERTED.CDPRODUTO; 

            UPDATE PRODOCORRE
            SET DTULTATUPOCO = GETDATE()
            FROM INSERTED
            WHERE PRODOCORRE.CDPRODUTO  = INSERTED.CDPRODUTO; 

            UPDATE PRODLOJA
            SET DTULTATUPLOJ = GETDATE()
            FROM INSERTED
            WHERE PRODLOJA.CDPRODUTO  = INSERTED.CDPRODUTO;

            UPDATE PRODUTOSEG
            SET DTULTATUPSEG = GETDATE()
            FROM INSERTED
            WHERE PRODUTOSEG.CDPRODUTO  = INSERTED.CDPRODUTO; 

   END;
END;
GO

UPDATE ITEMPRECO SET DTULTATUITPR = GETDATE() WHERE DTULTATUITPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUITPR' and
            type = 'D')
   ALTER TABLE ITEMPRECO DROP CONSTRAINT DEFAULT_DTULTATUITPR
GO

ALTER TABLE ITEMPRECO ADD CONSTRAINT DEFAULT_DTULTATUITPR
DEFAULT GETDATE()
FOR DTULTATUITPR
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ITEMPRECO','5.07.005';
GO

